# $Revision: 1.96 $, $Date: 2009/02/07 16:57:17 $
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	kernel		# without kernel packages
%bcond_without	userspace	# don't build userspace programs
%bcond_with	verbose		# verbose build (V=1)

%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%define		pname		xorg-driver-video-nvidia-legacy
%define		rel		12

Summary:	Linux Drivers for very old nVidia Chips: TNT, TNT2, Vanta, Vanta LT, GeForce 256, GeForce DDR, GeForce2, Quadro2 Pro
Summary(pl.UTF-8):	Sterowniki do bardzo starych kart graficznych nVidia: TNT, TNT2, Vanta, Vanta LT, GeForce 256, GeForce DDR, GeForce2, Quadro2 Pro
Name:		%{pname}%{_alt_kernel}
Version:	71.86.07
Release:	%{rel}
License:	nVidia Binary
Group:		X11
Source0:	ftp://download.nvidia.com/XFree86/Linux-x86/%{version}/NVIDIA-Linux-x86-%{version}-pkg0.run
# Source0-md5:	70dabbe1c88b564e5367d36c9c7badb9
Source1:	ftp://download.nvidia.com/XFree86/Linux-x86_64/%{version}/NVIDIA-Linux-x86_64-%{version}-pkg0.run
# Source1-md5:	00e84cec96884da1dc37ee29e013263e
Patch0:		X11-driver-nvidia-legacy-gcc34.patch
Patch1:		X11-driver-nvidia-legacy-GL.patch
Patch2:		%{pname}-desktop.patch
URL:		http://www.nvidia.com/object/unix.html
BuildRequires:	%{kgcc_package}
%if %{with kernel} && %{with dist_kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.20.2
%endif
BuildRequires:	rpmbuild(macros) >= 1.379
BuildConflicts:	XFree86-nvidia
Requires:	xorg-xserver-server
Requires:	xorg-xserver-server(videodrv-abi) >= 2.0
Requires:	xorg-xserver-server(videodrv-abi) < 3.0
Provides:	OpenGL = 1.5
Provides:	OpenGL-GLX = 1.3
Provides:	xorg-xserver-module(glx)
Obsoletes:	Mesa
Obsoletes:	X11-OpenGL-core < 1:7.0.0
Obsoletes:	X11-OpenGL-libGL < 1:7.0.0
Obsoletes:	XFree86-OpenGL-core < 1:7.0.0
Obsoletes:	XFree86-OpenGL-libGL < 1:7.0.0
Obsoletes:	XFree86-driver-nvidia
Obsoletes:	XFree86-nvidia
Conflicts:	Mesa-libGL
Conflicts:	XFree86-OpenGL-devel <= 4.2.0-3
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreqdep	libGL.so.1 libGLcore.so.1

%description
This driver set adds improved 2D functionality to the Xorg X server as
well as high performance OpenGL acceleration, AGP support, support for
most flat panels, and multiple monitor support.

Hardware: nVidia TNT, TNT2, Vanta, GeForce, old GeForce2 or Quadro based
graphics accelerator. Most recent adapters are supported by
xorg-driver-video-nvidia package. The nVidia NV1 and RIVA 128/128ZX
chips are supported by Open-Source nv driver from Xorg suite
and are no longer supported by vendor proprietary drivers.

%description -l pl.UTF-8
Usprawnione sterowniki dla kart graficznych nVidia do serwera Xorg X,
dające wysokowydajną akcelerację OpenGL, obsługę AGP i wielu
monitorów.

Obsługują karty nVidia TNT, TNT2, Vanta, GeForce, starsze GeForce2 Quadro.
Najnowsze karty są obsługiwane przez pakiet xorg-driver-video-nvidia.
Karty nVidia NV1 i Riva 128/128ZX są obsługiwane przez otwarty sterownik
nv z instalacji Xorg i nie są już obsługiwane przez własnościowe
sterowniki producenta.

%package devel
Summary:	OpenGL (GL and GLX) header files
Summary(pl.UTF-8):	Pliki nagłówkowe OpenGL (GL i GLX)
Group:		X11/Development/Libraries
Requires:	%{pname} = %{version}-%{release}
Provides:	OpenGL-GLX-devel = 1.3
Provides:	OpenGL-devel = 1.5
Obsoletes:	X11-OpenGL-devel-base
Obsoletes:	XFree86-OpenGL-devel-base
Obsoletes:	XFree86-driver-nvidia-devel
Conflicts:	XFree86-OpenGL-devel < 4.3.99.902-0.3

%description devel
OpenGL header files (GL and GLX only) for NVIDIA OpenGL
implementation.

%description devel -l pl.UTF-8
Pliki nagłówkowe OpenGL (tylko GL i GLX) dla implementacji OpenGL
firmy NVIDIA.

%package static
Summary:	Static XvMCNVIDIA library
Summary(pl.UTF-8):	Statyczna biblioteka XvMCNVIDIA
Group:		X11/Development/Libraries
Requires:	%{pname}-devel = %{version}-%{release}

%description static
Static XvMCNVIDIA library.

%description static -l pl.UTF-8
Statyczna biblioteka XvMCNVIDIA.

%package progs
Summary:	Tools for advanced control of nVidia graphic cards
Summary(pl.UTF-8):	Narzędzia do zarządzania kartami graficznymi nVidia
Group:		Applications/System
Requires:	%{pname} = %{version}-%{release}
Obsoletes:	XFree86-driver-nvidia-progs

%description progs
Tools for advanced control of nVidia graphic cards.

%description progs -l pl.UTF-8
Narzędzia do zarządzania kartami graficznymi nVidia.

%package -n kernel%{_alt_kernel}-video-nvidia-legacy
Summary:	nVidia kernel module for nVidia Architecture support
Summary(de.UTF-8):	Das nVidia-Kern-Modul für die nVidia-Architektur-Unterstützung
Summary(pl.UTF-8):	Moduł jądra dla obsługi kart graficznych nVidia
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
Requires:	dev >= 2.7.7-10
%{?with_dist_kernel:%requires_releq_kernel}
Provides:	X11-driver-nvidia(kernel)
Obsoletes:	XFree86-nvidia-kernel

%description -n kernel%{_alt_kernel}-video-nvidia-legacy
nVidia Architecture support for Linux kernel.

%description -n kernel%{_alt_kernel}-video-nvidia-legacy -l de.UTF-8
Die nVidia-Architektur-Unterstützung für den Linux-Kern.

%description -n kernel%{_alt_kernel}-video-nvidia-legacy -l pl.UTF-8
Obsługa architektury nVidia dla jądra Linuksa. Pakiet wymagany przez
sterownik nVidii dla XFree86 4.

%prep
cd %{_builddir}
rm -rf NVIDIA-Linux-x86*%{version}-pkg*
%ifarch %{ix86}
/bin/sh %{SOURCE0} --extract-only
%setup -qDT -n NVIDIA-Linux-x86-%{version}-pkg0
%else
/bin/sh %{SOURCE1} --extract-only
%setup -qDT -n NVIDIA-Linux-x86_64-%{version}-pkg0
%endif
%patch0 -p1
%patch1 -p1
%patch2 -p1
echo 'EXTRA_CFLAGS += -Wno-pointer-arith -Wno-sign-compare -Wno-unused' >> usr/src/nv/Makefile.kbuild

%build
%if %{with kernel}
cd usr/src/nv/
ln -sf Makefile.kbuild Makefile
cat >> Makefile <<'EOF'

$(obj)/nv-kernel.o: $(src)/nv-kernel.o.bin
	cp $< $@
EOF
mv nv-kernel.o{,.bin}
%build_kernel_modules -m nvidia
%endif

%install
rm -rf $RPM_BUILD_ROOT
%if %{with userspace}
install -d $RPM_BUILD_ROOT%{_includedir}/GL

install -D {usr/bin,$RPM_BUILD_ROOT%{_bindir}}/nvidia-settings
install -D {usr/lib/tls,$RPM_BUILD_ROOT%{_libdir}}/libnvidia-tls.so.%{version}
install -D {usr/X11R6/lib,$RPM_BUILD_ROOT%{_libdir}/xorg}/modules/extensions/libglx.so.%{version}
install -D {usr/lib,$RPM_BUILD_ROOT%{_libdir}}/libGL.so.%{version}
install -D {usr/lib,$RPM_BUILD_ROOT%{_libdir}}/libGLcore.so.%{version}
install -D {usr/X11R6/lib,$RPM_BUILD_ROOT%{_libdir}}/libXvMCNVIDIA.so.%{version}
install -D {usr/X11R6/lib,$RPM_BUILD_ROOT%{_libdir}}/libXvMCNVIDIA.a

install -D {usr/X11R6/lib,$RPM_BUILD_ROOT%{_libdir}/xorg}/modules/drivers/nvidia_drv.so
install usr/include/GL/*.h $RPM_BUILD_ROOT%{_includedir}/GL

ln -sf libglx.so.%{version} $RPM_BUILD_ROOT%{_libdir}/xorg/modules/extensions/libglx.so
ln -sf libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libXvMCNVIDIA.so
ln -sf libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libXvMCNVIDIA_dynamic.so.1

# OpenGL ABI for Linux compatibility
ln -sf libGL.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libGL.so.1
ln -sf libGL.so.1 $RPM_BUILD_ROOT%{_libdir}/libGL.so

install -D {usr/share/applications,$RPM_BUILD_ROOT%{_desktopdir}}/nvidia-settings.desktop
install -D {usr/share/pixmaps,$RPM_BUILD_ROOT%{_pixmapsdir}}/nvidia-settings.png
%endif

%if %{with kernel}
%install_kernel_modules -m usr/src/nv/nvidia -d misc
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
cat << EOF
NOTE: You must install:
kernel-video-nvidia-legacy-%{version}
for this driver to work
EOF

%postun	-p /sbin/ldconfig

%post	-n kernel%{_alt_kernel}-video-nvidia-legacy
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-video-nvidia-legacy
%depmod %{_kernel_ver}

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc LICENSE usr/share/doc/{README,NVIDIA_Changelog,XF86Config.sample}
%attr(755,root,root) %{_libdir}/libGL.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libGL.so.1
# symlink for binary apps which fail to conform Linux OpenGL ABI
# (and dlopen libGL.so instead of libGL.so.1)
%attr(755,root,root) %{_libdir}/libGL.so
%attr(755,root,root) %{_libdir}/libGLcore.so.*.*
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA.so.*.*
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA_dynamic.so.1
%attr(755,root,root) %{_libdir}/libnvidia-tls.so.*.*.*
%attr(755,root,root) %{_libdir}/xorg/modules/drivers/nvidia_drv.so
%attr(755,root,root) %{_libdir}/xorg/modules/extensions/libglx.so*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA.so
%dir %{_includedir}/GL
%{_includedir}/GL/gl.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/glx.h
%{_includedir}/GL/glxtokens.h

%files static
%defattr(644,root,root,755)
%{_libdir}/libXvMCNVIDIA.a

%files progs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/nvidia-settings
%{_desktopdir}/nvidia-settings.desktop
%{_pixmapsdir}/nvidia-settings.png
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-video-nvidia-legacy
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: xorg-driver-video-nvidia-legacy.spec,v $
Revision 1.96  2009/02/07 16:57:17  arekm
- release 12

Revision 1.95  2009/02/04 23:55:48  hawk
- use pak0 (without useless prebuilt kernel modules)

Revision 1.94  2009/01/25 12:55:53  arekm
- release 11

Revision 1.93  2009/01/19 12:30:34  arekm
- release 10

Revision 1.92  2009/01/15 12:54:18  arekm
- release 9

Revision 1.91  2009/01/10 22:37:39  arekm
- release 8

Revision 1.90  2008/12/27 09:00:20  qboosh
- glx extension module provides should be pure virtual

Revision 1.89  2008/12/19 06:31:16  arekm
- release 7

Revision 1.88  2008/12/14 11:43:14  arekm
- release 6

Revision 1.87  2008/12/06 09:00:30  arekm
- release 5

Revision 1.86  2008/12/02 08:46:41  qwiat
- more precise descriptions

Revision 1.85  2008/11/21 16:16:00  arekm
- release 3

Revision 1.84  2008/11/08 09:27:11  arekm
- release 2

Revision 1.83  2008/11/04 19:54:06  arekm
- up to beta 71.86.07 (works again on non-SSE cpus); no support for xserver 1.5

Revision 1.82  2008/10/13 20:48:02  arekm
- release 9

Revision 1.81  2008/10/08 18:55:05  arekm
- major abi cannot change

Revision 1.80  2008/09/09 09:02:11  hawk
- release 8

Revision 1.79  2008/09/02 06:42:31  arekm
- release 7

Revision 1.78  2008/08/30 16:33:53  arekm
- release 6

Revision 1.77  2008/08/06 20:20:48  hawk
- release 5

Revision 1.76  2008/08/03 10:20:14  arekm
- release 4

Revision 1.75  2008/07/29 10:32:30  hawk
- release 3

Revision 1.74  2008/07/25 07:10:23  arekm
- release 2

Revision 1.73  2008/07/22 13:40:35  hawk
- updated to 71.86.06

Revision 1.72  2008/07/19 08:01:59  arekm
- release 18

Revision 1.71  2008/07/15 09:16:28  arekm
- release 17

Revision 1.70  2008/07/02 20:44:31  arekm
- release 16

Revision 1.69  2008/07/01 16:09:32  arekm
- release 15

Revision 1.68  2008/06/26 06:46:58  arekm
- release 14

Revision 1.67  2008/06/24 11:27:34  arekm
- release 13

Revision 1.66  2008/06/23 19:18:51  hawk
- release 12

Revision 1.65  2008/06/11 15:52:07  hawk
- release 11

Revision 1.64  2008-06-08 16:52:20  hawk
- release 10

Revision 1.63  2008-05-24 10:08:25  hawk
- release 9

Revision 1.62  2008-05-05 06:53:43  hawk
- release 8

Revision 1.61  2008-04-30 21:47:10  hawk
- fix building with kernel 2.6.25

Revision 1.60  2008-04-07 20:52:08  twittner
- too much '}' ?

Revision 1.59  2008-03-27 20:56:54  glen
- rel 7 (2.6.22.19-5)

Revision 1.58  2008-03-10 12:22:49  arekm
- release 6

Revision 1.57  2008-02-29 08:25:05  hawk
- release 5

Revision 1.56  2008-02-11 11:33:26  arekm
- rel 4

Revision 1.55  2008-02-08 08:51:45  hawk
- release 3

Revision 1.54  2008-02-03 07:39:36  hawk
- release 2

Revision 1.53  2008-01-30 20:39:34  hawk
- updated to 71.86.04

Revision 1.52  2008-01-23 18:17:11  hawk
- dropped outdated and unecessary verbose patch
- suffix src package with alt kernel name (if present)
- disable userspace for alt_kernels
- cleanup

Revision 1.51  2008-01-22 22:54:27  glen
- rel 7 (2.6.16.59-2)

Revision 1.50  2007-12-17 14:20:52  arekm
- rel .6

Revision 1.49  2007-12-15 12:03:16  arekm
- rel 5

Revision 1.48  2007-11-29 08:08:06  arekm
- rel 4

Revision 1.47  2007-11-25 10:34:22  arekm
- rel 3

Revision 1.46  2007-11-09 18:17:01  patrys
- don't obsolete mesa-libgl

Revision 1.45  2007-11-01 07:40:03  shadzik
- rel 1

Revision 1.44  2007/10/20 12:08:19  qboosh
- updated URL

Revision 1.43  2007/10/20 10:22:11  qboosh
- simplified

Revision 1.42  2007/10/20 10:13:17  twittner
- lower rel. to 0.1 - sth is not right:
Xlib:  extension "GLX" missing on display ":0.0".
Error: couldn't get an RGB, Double-buffered visual

Revision 1.41  2007/10/20 00:02:04  twittner
- md5

Revision 1.40  2007/10/19 23:48:38  twittner
- up to 71.86.01 (xorg-xserver-server(videodrv-abi) = 2.0)

Revision 1.39  2007/10/12 12:52:06  arekm
- rel 3

Revision 1.38  2007/09/10 17:02:25  arekm
- require old ABI not available in xserver 1.4

Revision 1.37  2007/09/06 19:45:55  arekm
- rebuilding for new xserver

Revision 1.36  2007/08/27 06:28:50  qboosh
- separated -static (libXvMCNVIDIA.a)
- better description for -devel
- versioned OpenGL-GLX* Provides (1.3)
- dropped OpenGL-devel-base cap; obsolete old X*-OpenGL-devel-base packages
- fixed libGL* symlinks, include libGL.so.1 symlink as ghost

Revision 1.35  2007/07/23 18:21:16  qboosh
- no circular symlinks

Revision 1.34  2007/07/19 18:50:56  twittner
- complete %{_perfix}/%{_lib} -> %{_libdir} changes. Since xorg uses
  /usr as prefix not /usr/X11R6 so there is not difference between
  %{_perfix}/%{_lib} and %{_libdir}

Revision 1.33  2007/07/19 17:22:52  twittner
- up to 1.0-7185
- %files fixes - please check it - rel. 0.1

Revision 1.32  2007/06/26 16:24:02  qboosh
- updated banners (no more 24 or smp), decreased their annoyance

Revision 1.31  2007/06/08 21:44:15  arekm
- rebuild

Revision 1.30  2007/04/20 10:22:21  pluto
- bump release and rebuild with 2.6.20.7.

Revision 1.29  2007/04/08 23:50:13  shadzik
- proper rpm macros are not enough, you need also a proper kernel (updated kernel-module-build version)

Revision 1.28  2007/04/08 23:45:38  shadzik
- kernel-module-build epoch

Revision 1.27  2007/04/07 11:43:00  twittner
- rel. 2

Revision 1.26  2007/04/06 23:17:30  twittner
- fix %files

Revision 1.25  2007/04/06 23:15:41  twittner
- install nvidia.so instead .o

Revision 1.24  2007/04/06 21:28:43  twittner
- O: Mesa-libGL (like xorg-driver-video-nvidia.spec)

Revision 1.23  2007/04/06 21:09:55  twittner
- one more /xorg/ added

Revision 1.22  2007/04/06 21:01:10  twittner
- added missisng /xorg/ paths

Revision 1.21  2007/04/06 20:35:40  shadzik
- kill logs from other specs

Revision 1.20  2007/04/06 20:31:42  shadzik
- proper macros BR

Revision 1.19  2007/04/06 20:26:16  twittner
- requires_releq_kernel_{up,smp} replaced with requires_releq_kernel
  and dropped smp subpackages - (as zbyniu suggested)

Revision 1.18  2007/04/01 16:48:24  qboosh
- updated descs from obsolete X11-driver-nvidia-legacy.spec (still need update
  for next part of hardware support dropped recently)
- dropped _patchname macro (not needed and misleading)

Revision 1.17  2007/02/19 14:13:21  baggins
- fix libglx provides

Revision 1.16  2007/02/12 22:09:24  glen
- tabs in preamble

Revision 1.15  2007/02/12 01:06:45  baggins
- converted to UTF-8

Revision 1.14  2007/01/06 22:47:46  arekm
- obsolete only Ac version of X11 so metapackage-xorg will have a chance to work

Revision 1.13  2006/12/01 14:03:13  shadzik
- cleanup, cosmetics, adapterised and more Th optimizations

Revision 1.12  2006/12/01 13:38:52  shadzik
- package nvidia_drv.o.gz instead of not existing *.o
- call it everywhere *nvidia-legacy

Revision 1.11  2006/12/01 12:41:35  shadzik
- R:, P:, O:
- be more th friendly

Revision 1.10  2006/11/14 20:13:34  sparky
- BR: rpmbuild(macros) >= 1.330, for fixed %build_kernel_modules macro

Revision 1.9  2006/11/13 19:04:50  sparky
- save binary nv-kernel.o file

Revision 1.8  2006/11/13 12:27:13  sparky
- %{_alt_kernel} support
- use %build_kernel_modules, %install_kernel_modules (not tested)

Revision 1.7  2006/11/01 16:06:08  shadzik
- really fix Name (thx qboosh), return to _patchname

Revision 1.6  2006/11/01 15:41:13  shadzik
- fix patch0 entry

Revision 1.5  2006/11/01 15:40:32  shadzik
- ups, it's verbose.patch not conftest.patch as patch2

Revision 1.4  2006/11/01 15:37:59  shadzik
- use patches from ac nvidia-legacy

Revision 1.3  2006/11/01 15:18:58  shadzik
- fix Name and define _patchname

Revision 1.2  2006/11/01 15:07:07  shadzik
- 7184

Revision 1.1  2006/11/01 14:59:12  shadzik
- fill the hole, merged from xorg-driver-video-nvidia.spec rev. 1.48
